// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/container/DynamicListClassnameContainer.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/container/DynamicListPairContainer.h
 *  \brief Store a list of ParticlePairsTemp
 *
 *  Copyright 2007-2016 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H
#define IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/object_macros.h>
#include <IMP/internal/DynamicListContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a ParticleIndexPairs
/** In contrast to ListPairContainer, this list is designed to act
    as the output of a ScoreState or another container. The key difference
    is that it uses the passed Container to define the list of all
    possible contents of the container.
 */
class IMPCONTAINEREXPORT DynamicListPairContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public PairContainer
#else
    public IMP::internal::DynamicListContainer<PairContainer>
#endif
    {
  typedef IMP::internal::DynamicListContainer<PairContainer> P;

 public:
  /** Constructs the dynamic list

      @param scope a container with a list of all possible particles that
                   are allowed to be dynamically added or removed in this
                   container
      @param name  the name of this container
  */
  DynamicListPairContainer(Container *scope, std::string name =
                                                  "ListPairContainer %1%");

  /** @name Methods to control the contained objects

      This container stores a list of Pair objects. To manipulate
      the list use these methods.
   */
  /**@{*/
#if defined(SWIG) || defined(IMP_DOXYGEN)
  //! Add a single const ParticleIndexPair& to the container.
  void add(const ParticleIndexPair& vt);

  //! Add ParticleIndexPairs to the container.
  void add(const ParticleIndexPairs &c);

  //! Set the contents of the container to the given ParticleIndexPairs.
  void set(ParticleIndexPairs cp);

  //! Clear the contents of the container.
  void clear();
#endif
  /** \deprecated_at{2.5} Use add() with indexes instead */
  IMPCONTAINER_DEPRECATED_METHOD_DECL(2.5)
  void add_particle_pair(const ParticlePair& vt);

  /** \deprecated_at{2.5} Use add() with indexes instead */
  IMPCONTAINER_DEPRECATED_METHOD_DECL(2.5)
  void add_particle_pairs(const ParticlePairsTemp &c);

  /** \deprecated_at{2.5} Use set() instead */
  IMPCONTAINER_DEPRECATED_METHOD_DECL(2.5)
  void set_particle_pairs(ParticlePairsTemp c);

  /** \deprecated_at{2.5} Use clear() instead */
  IMPCONTAINER_DEPRECATED_METHOD_DECL(2.5)
  void clear_particle_pairs();

/**@}*/
#ifdef SWIG
  ParticleIndexPairs get_indexes() const;
  ParticleIndexPairs get_range_indexes() const;
  ModelObjectsTemp do_get_inputs() const;
  void do_apply(const PairModifier *sm) const;
  ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(DynamicListPairContainer);
};

IMP_OBJECTS(DynamicListPairContainer, DynamicListPairContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H */
